export function format(ast) {
    return ast.map(formatStatement);
}
function formatStatement(stm) {
    if (stm.command === 'SELECT') {
        return formatSelect(stm);
    }
    else {
        throw new Error(`Unsupported command: ${stm.command}`);
    }
}
function formatSelect(select) {
    return {
        command: 'SELECT',
        language: 'DML',
        operation: 'read',
        result: { columns: select.result.columns.map(formatSelectResultColumn) },
        from: { table: { entity: select.from.table.identifier } },
        joins: []
    };
}
function formatSelectResultColumn(col) {
    const alias = col.alias?.identifier;
    if ('identifier' in col.column) {
        return { name: col.column.identifier, alias, content: { kind: 'column', column: [col.column.identifier], table: col.table?.identifier, schema: col.schema?.identifier } };
    }
    else {
        return { name: col.column.wildcard, alias, content: { kind: 'wildcard', table: col.table?.identifier, schema: col.schema?.identifier } };
    }
}
//# sourceMappingURL=formatter.js.map