import { EmbeddedActionsParser, TokenType } from "chevrotain";
import { BooleanAst, ColumnRefAst, ConditionAst, ConditionElemAst, ConditionOpAst, IdentifierAst, IntegerAst, SelectAst, SelectColumnAst, SelectFromAst, SelectResultAst, SelectWhereAst, SqlScriptAst, StatementAst, StringAst, TableRefAst } from "./ast";
import { ParserResult } from "@azimutt/models";
declare class SqlParser extends EmbeddedActionsParser {
    integerRule: () => IntegerAst;
    stringRule: () => StringAst;
    booleanRule: () => BooleanAst;
    identifierRule: () => IdentifierAst;
    namespaceRule: () => IdentifierAst;
    tableRefRule: () => TableRefAst;
    columnRefRule: () => ColumnRefAst;
    conditionOpRule: () => ConditionOpAst;
    conditionElemRule: () => ConditionElemAst;
    conditionRule: () => ConditionAst;
    selectResultColumnRule: () => SelectColumnAst;
    selectResultRule: () => SelectResultAst;
    selectFromRule: () => SelectFromAst;
    selectWhereRule: () => SelectWhereAst;
    selectRule: () => SelectAst;
    statementRule: () => StatementAst;
    sqlScriptRule: () => SqlScriptAst;
    constructor(tokens: TokenType[]);
}
export declare function parseRule<T>(parse: (p: SqlParser) => T, input: string): ParserResult<T>;
export declare function parse(input: string): ParserResult<SqlScriptAst>;
export {};
//# sourceMappingURL=parser.d.ts.map