import { Database, Entity, ParserError, ParserResult } from "@azimutt/models";
import { PostgresAst, SelectInnerAst, StatementAst, TokenInfo } from "./postgresAst";
export declare function buildPostgresDatabase(ast: PostgresAst, start: number, parsed: number): ParserResult<Database>;
export declare function evolvePostgres(db: Database, errors: ParserError[], index: number, stmt: StatementAst): void;
export type SelectEntities = {
    columns: SelectColumn[];
    sources: SelectSource[];
};
export type SelectColumn = {
    schema?: string;
    table?: string;
    name: string;
    type?: string;
    sources: SelectColumnSource[];
    token: TokenInfo;
};
export type SelectColumnSource = {
    schema?: string;
    table: string;
    column: string;
    type?: string;
};
export type SelectSource = {
    name: string;
    from: SelectSourceFrom;
};
export type SelectSourceFrom = SelectSourceTable | SelectSourceSelect;
export type SelectSourceTable = {
    kind: 'Table';
    schema?: string;
    table: string;
    columns?: {
        name: string;
        type: string;
    }[];
};
export type SelectSourceSelect = {
    kind: 'Select';
} & SelectEntities;
export declare function selectEntities(s: SelectInnerAst, entities: Entity[]): SelectEntities;
//# sourceMappingURL=postgresBuilder.d.ts.map