import { EmbeddedActionsParser, IToken, TokenType } from "chevrotain";
import { ParserResult } from "@azimutt/models";
import { AliasAst, AlterFunctionStatementAst, AlterMaterializedViewStatementAst, AlterSchemaStatementAst, AlterSequenceStatementAst, AlterTableStatementAst, AlterTypeStatementAst, AlterViewStatementAst, BeginStatementAst, BooleanAst, ColumnTypeAst, CommentAst, CommentOnStatementAst, CommitStatementAst, CreateExtensionStatementAst, CreateFunctionStatementAst, CreateIndexStatementAst, CreateMaterializedViewStatementAst, CreateSchemaStatementAst, CreateSequenceStatementAst, CreateTableStatementAst, CreateTriggerStatementAst, CreateTypeStatementAst, CreateViewStatementAst, DecimalAst, DeleteStatementAst, DropStatementAst, ExpressionAst, FromClauseAst, IdentifierAst, InsertIntoStatementAst, IntegerAst, LiteralAst, NullAst, ObjectNameAst, ParameterAst, PostgresAst, PostgresStatementAst, SelectClauseAst, SelectStatementAst, SetStatementAst, ShowStatementAst, StatementAst, StatementsAst, StringAst, TableColumnAst, TableConstraintAst, TokenAst, UpdateStatementAst, WhereClauseAst } from "./postgresAst";
declare class PostgresParser extends EmbeddedActionsParser {
    statementsRule: () => StatementsAst;
    statementRule: () => StatementAst;
    alterFunctionStatementRule: (alter: IToken) => AlterFunctionStatementAst;
    alterMaterializedViewStatementRule: (alter: IToken) => AlterMaterializedViewStatementAst;
    alterSchemaStatementRule: (alter: IToken) => AlterSchemaStatementAst;
    alterSequenceStatementRule: (alter: IToken) => AlterSequenceStatementAst;
    alterTableStatementRule: (alter: IToken) => AlterTableStatementAst;
    alterTypeStatementRule: (alter: IToken) => AlterTypeStatementAst;
    alterViewStatementRule: (alter: IToken) => AlterViewStatementAst;
    beginStatementRule: () => BeginStatementAst;
    commentOnStatementRule: () => CommentOnStatementAst;
    commitStatementRule: () => CommitStatementAst;
    createExtensionStatementRule: (create: IToken) => CreateExtensionStatementAst;
    createFunctionStatementRule: (create: IToken, replace?: TokenAst) => CreateFunctionStatementAst;
    createIndexStatementRule: (create: IToken) => CreateIndexStatementAst;
    createMaterializedViewStatementRule: (create: IToken) => CreateMaterializedViewStatementAst;
    createSchemaStatementRule: (create: IToken) => CreateSchemaStatementAst;
    createSequenceStatementRule: (create: IToken) => CreateSequenceStatementAst;
    createTableStatementRule: (create: IToken) => CreateTableStatementAst;
    createTriggerStatementRule: (create: IToken, replace?: TokenAst) => CreateTriggerStatementAst;
    createTypeStatementRule: (create: IToken) => CreateTypeStatementAst;
    createViewStatementRule: (create: IToken, replace?: TokenAst) => CreateViewStatementAst;
    deleteStatementRule: () => DeleteStatementAst;
    dropStatementRule: () => DropStatementAst;
    insertIntoStatementRule: () => InsertIntoStatementAst;
    selectStatementRule: () => SelectStatementAst;
    setStatementRule: () => SetStatementAst;
    showStatementRule: () => ShowStatementAst;
    updateStatementRule: () => UpdateStatementAst;
    selectClauseRule: () => SelectClauseAst;
    fromClauseRule: () => FromClauseAst;
    whereClauseRule: () => WhereClauseAst;
    tableColumnRule: () => TableColumnAst;
    tableConstraintRule: () => TableConstraintAst;
    aliasRule: () => AliasAst;
    expressionRule: () => ExpressionAst;
    objectNameRule: () => ObjectNameAst;
    columnTypeRule: () => ColumnTypeAst;
    literalRule: () => LiteralAst;
    parameterRule: () => ParameterAst;
    identifierRule: () => IdentifierAst;
    stringRule: () => StringAst;
    integerRule: () => IntegerAst;
    decimalRule: () => DecimalAst;
    booleanRule: () => BooleanAst;
    nullRule: () => NullAst;
    constructor(tokens: TokenType[], recovery: boolean);
}
export declare function parseRule<T extends object>(parse: (p: PostgresParser) => T, input: string, strict?: boolean): ParserResult<T & {
    comments?: CommentAst[];
}>;
export declare function parsePostgresAst(input: string, opts?: {
    strict?: boolean;
}): ParserResult<PostgresAst>;
export declare function parsePostgresStatementAst(input: string, opts?: {
    strict?: boolean;
}): ParserResult<PostgresStatementAst>;
export {};
//# sourceMappingURL=postgresParser.d.ts.map