import { z } from "zod";
export { Select } from "./select";
export declare const SqlStatement: z.ZodDiscriminatedUnion<"command", [z.ZodObject<{
    command: z.ZodLiteral<"CREATE TABLE">;
    language: z.ZodLiteral<"DDL">;
    operation: z.ZodLiteral<"schema">;
}, "strict", z.ZodTypeAny, {
    command: "CREATE TABLE";
    language: "DDL";
    operation: "schema";
}, {
    command: "CREATE TABLE";
    language: "DDL";
    operation: "schema";
}>, z.ZodObject<{
    command: z.ZodLiteral<"GRANT">;
    language: z.ZodLiteral<"DCL">;
    operation: z.ZodLiteral<"rights">;
}, "strict", z.ZodTypeAny, {
    command: "GRANT";
    language: "DCL";
    operation: "rights";
}, {
    command: "GRANT";
    language: "DCL";
    operation: "rights";
}>, z.ZodObject<{
    command: z.ZodLiteral<"ROLLBACK">;
    language: z.ZodLiteral<"TCL">;
    operation: z.ZodLiteral<"transaction">;
}, "strict", z.ZodTypeAny, {
    command: "ROLLBACK";
    language: "TCL";
    operation: "transaction";
}, {
    command: "ROLLBACK";
    language: "TCL";
    operation: "transaction";
}>, z.ZodObject<{
    command: z.ZodLiteral<"SELECT">;
    language: z.ZodLiteral<"DML">;
    operation: z.ZodLiteral<"read">;
    result: z.ZodObject<{
        columns: z.ZodArray<z.ZodObject<{
            content: z.ZodDiscriminatedUnion<"kind", [z.ZodObject<{
                kind: z.ZodLiteral<"wildcard">;
                table: z.ZodOptional<z.ZodString>;
                schema: z.ZodOptional<z.ZodString>;
            }, "strip", z.ZodTypeAny, {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            }, {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            }>, z.ZodObject<z.objectUtil.extendShape<{
                database: z.ZodOptional<z.ZodString>;
                catalog: z.ZodOptional<z.ZodString>;
                schema: z.ZodOptional<z.ZodString>;
            }, {
                kind: z.ZodLiteral<"column">;
                table: z.ZodOptional<z.ZodString>;
                column: z.ZodArray<z.ZodString, "many">;
            }>, "strict", z.ZodTypeAny, {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            }, {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            }>, z.ZodObject<{
                kind: z.ZodLiteral<"expression">;
                text: z.ZodString;
                columns: z.ZodOptional<z.ZodArray<z.ZodObject<z.objectUtil.extendShape<{
                    database: z.ZodOptional<z.ZodString>;
                    catalog: z.ZodOptional<z.ZodString>;
                    schema: z.ZodOptional<z.ZodString>;
                }, {
                    kind: z.ZodLiteral<"column">;
                    table: z.ZodOptional<z.ZodString>;
                    column: z.ZodArray<z.ZodString, "many">;
                }>, "strict", z.ZodTypeAny, {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }, {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }>, "many">>;
            }, "strip", z.ZodTypeAny, {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            }, {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            }>]>;
            alias: z.ZodOptional<z.ZodString>;
            name: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }, {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }>, "many">;
        distinct: z.ZodOptional<z.ZodBoolean>;
    }, "strip", z.ZodTypeAny, {
        columns: {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }[];
        distinct?: boolean | undefined;
    }, {
        columns: {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }[];
        distinct?: boolean | undefined;
    }>;
    from: z.ZodType<import("./select").From, z.ZodTypeDef, import("./select").From>;
    joins: z.ZodOptional<z.ZodArray<z.ZodType<import("./select").From, z.ZodTypeDef, import("./select").From>, "many">>;
}, "strict", z.ZodTypeAny, {
    command: "SELECT";
    language: "DML";
    operation: "read";
    result: {
        columns: {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }[];
        distinct?: boolean | undefined;
    };
    from: import("./select").From;
    joins?: import("./select").From[] | undefined;
}, {
    command: "SELECT";
    language: "DML";
    operation: "read";
    result: {
        columns: {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }[];
        distinct?: boolean | undefined;
    };
    from: import("./select").From;
    joins?: import("./select").From[] | undefined;
}>, z.ZodObject<{
    command: z.ZodLiteral<"UPDATE">;
    language: z.ZodLiteral<"DML">;
    operation: z.ZodLiteral<"write">;
}, "strict", z.ZodTypeAny, {
    command: "UPDATE";
    language: "DML";
    operation: "write";
}, {
    command: "UPDATE";
    language: "DML";
    operation: "write";
}>]>;
export type SqlStatement = z.infer<typeof SqlStatement>;
export declare const SqlScript: z.ZodArray<z.ZodDiscriminatedUnion<"command", [z.ZodObject<{
    command: z.ZodLiteral<"CREATE TABLE">;
    language: z.ZodLiteral<"DDL">;
    operation: z.ZodLiteral<"schema">;
}, "strict", z.ZodTypeAny, {
    command: "CREATE TABLE";
    language: "DDL";
    operation: "schema";
}, {
    command: "CREATE TABLE";
    language: "DDL";
    operation: "schema";
}>, z.ZodObject<{
    command: z.ZodLiteral<"GRANT">;
    language: z.ZodLiteral<"DCL">;
    operation: z.ZodLiteral<"rights">;
}, "strict", z.ZodTypeAny, {
    command: "GRANT";
    language: "DCL";
    operation: "rights";
}, {
    command: "GRANT";
    language: "DCL";
    operation: "rights";
}>, z.ZodObject<{
    command: z.ZodLiteral<"ROLLBACK">;
    language: z.ZodLiteral<"TCL">;
    operation: z.ZodLiteral<"transaction">;
}, "strict", z.ZodTypeAny, {
    command: "ROLLBACK";
    language: "TCL";
    operation: "transaction";
}, {
    command: "ROLLBACK";
    language: "TCL";
    operation: "transaction";
}>, z.ZodObject<{
    command: z.ZodLiteral<"SELECT">;
    language: z.ZodLiteral<"DML">;
    operation: z.ZodLiteral<"read">;
    result: z.ZodObject<{
        columns: z.ZodArray<z.ZodObject<{
            content: z.ZodDiscriminatedUnion<"kind", [z.ZodObject<{
                kind: z.ZodLiteral<"wildcard">;
                table: z.ZodOptional<z.ZodString>;
                schema: z.ZodOptional<z.ZodString>;
            }, "strip", z.ZodTypeAny, {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            }, {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            }>, z.ZodObject<z.objectUtil.extendShape<{
                database: z.ZodOptional<z.ZodString>;
                catalog: z.ZodOptional<z.ZodString>;
                schema: z.ZodOptional<z.ZodString>;
            }, {
                kind: z.ZodLiteral<"column">;
                table: z.ZodOptional<z.ZodString>;
                column: z.ZodArray<z.ZodString, "many">;
            }>, "strict", z.ZodTypeAny, {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            }, {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            }>, z.ZodObject<{
                kind: z.ZodLiteral<"expression">;
                text: z.ZodString;
                columns: z.ZodOptional<z.ZodArray<z.ZodObject<z.objectUtil.extendShape<{
                    database: z.ZodOptional<z.ZodString>;
                    catalog: z.ZodOptional<z.ZodString>;
                    schema: z.ZodOptional<z.ZodString>;
                }, {
                    kind: z.ZodLiteral<"column">;
                    table: z.ZodOptional<z.ZodString>;
                    column: z.ZodArray<z.ZodString, "many">;
                }>, "strict", z.ZodTypeAny, {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }, {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }>, "many">>;
            }, "strip", z.ZodTypeAny, {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            }, {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            }>]>;
            alias: z.ZodOptional<z.ZodString>;
            name: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }, {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }>, "many">;
        distinct: z.ZodOptional<z.ZodBoolean>;
    }, "strip", z.ZodTypeAny, {
        columns: {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }[];
        distinct?: boolean | undefined;
    }, {
        columns: {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }[];
        distinct?: boolean | undefined;
    }>;
    from: z.ZodType<import("./select").From, z.ZodTypeDef, import("./select").From>;
    joins: z.ZodOptional<z.ZodArray<z.ZodType<import("./select").From, z.ZodTypeDef, import("./select").From>, "many">>;
}, "strict", z.ZodTypeAny, {
    command: "SELECT";
    language: "DML";
    operation: "read";
    result: {
        columns: {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }[];
        distinct?: boolean | undefined;
    };
    from: import("./select").From;
    joins?: import("./select").From[] | undefined;
}, {
    command: "SELECT";
    language: "DML";
    operation: "read";
    result: {
        columns: {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }[];
        distinct?: boolean | undefined;
    };
    from: import("./select").From;
    joins?: import("./select").From[] | undefined;
}>, z.ZodObject<{
    command: z.ZodLiteral<"UPDATE">;
    language: z.ZodLiteral<"DML">;
    operation: z.ZodLiteral<"write">;
}, "strict", z.ZodTypeAny, {
    command: "UPDATE";
    language: "DML";
    operation: "write";
}, {
    command: "UPDATE";
    language: "DML";
    operation: "write";
}>]>, "many">;
export type SqlScript = z.infer<typeof SqlScript>;
export type SqlScriptText = string;
export type SqlStatementText = string;
export type SqlFragmentText = string;
//# sourceMappingURL=index.d.ts.map