import { z } from "zod";
import { EntityRef } from "@azimutt/models";
export declare const Column: z.ZodObject<{
    content: z.ZodDiscriminatedUnion<"kind", [z.ZodObject<{
        kind: z.ZodLiteral<"wildcard">;
        table: z.ZodOptional<z.ZodString>;
        schema: z.ZodOptional<z.ZodString>;
    }, "strip", z.ZodTypeAny, {
        kind: "wildcard";
        schema?: string | undefined;
        table?: string | undefined;
    }, {
        kind: "wildcard";
        schema?: string | undefined;
        table?: string | undefined;
    }>, z.ZodObject<z.objectUtil.extendShape<{
        database: z.ZodOptional<z.ZodString>;
        catalog: z.ZodOptional<z.ZodString>;
        schema: z.ZodOptional<z.ZodString>;
    }, {
        kind: z.ZodLiteral<"column">;
        table: z.ZodOptional<z.ZodString>;
        column: z.ZodArray<z.ZodString, "many">;
    }>, "strict", z.ZodTypeAny, {
        kind: "column";
        column: string[];
        schema?: string | undefined;
        table?: string | undefined;
        database?: string | undefined;
        catalog?: string | undefined;
    }, {
        kind: "column";
        column: string[];
        schema?: string | undefined;
        table?: string | undefined;
        database?: string | undefined;
        catalog?: string | undefined;
    }>, z.ZodObject<{
        kind: z.ZodLiteral<"expression">;
        text: z.ZodString;
        columns: z.ZodOptional<z.ZodArray<z.ZodObject<z.objectUtil.extendShape<{
            database: z.ZodOptional<z.ZodString>;
            catalog: z.ZodOptional<z.ZodString>;
            schema: z.ZodOptional<z.ZodString>;
        }, {
            kind: z.ZodLiteral<"column">;
            table: z.ZodOptional<z.ZodString>;
            column: z.ZodArray<z.ZodString, "many">;
        }>, "strict", z.ZodTypeAny, {
            kind: "column";
            column: string[];
            schema?: string | undefined;
            table?: string | undefined;
            database?: string | undefined;
            catalog?: string | undefined;
        }, {
            kind: "column";
            column: string[];
            schema?: string | undefined;
            table?: string | undefined;
            database?: string | undefined;
            catalog?: string | undefined;
        }>, "many">>;
    }, "strip", z.ZodTypeAny, {
        kind: "expression";
        text: string;
        columns?: {
            kind: "column";
            column: string[];
            schema?: string | undefined;
            table?: string | undefined;
            database?: string | undefined;
            catalog?: string | undefined;
        }[] | undefined;
    }, {
        kind: "expression";
        text: string;
        columns?: {
            kind: "column";
            column: string[];
            schema?: string | undefined;
            table?: string | undefined;
            database?: string | undefined;
            catalog?: string | undefined;
        }[] | undefined;
    }>]>;
    alias: z.ZodOptional<z.ZodString>;
    name: z.ZodString;
}, "strip", z.ZodTypeAny, {
    content: {
        kind: "column";
        column: string[];
        schema?: string | undefined;
        table?: string | undefined;
        database?: string | undefined;
        catalog?: string | undefined;
    } | {
        kind: "expression";
        text: string;
        columns?: {
            kind: "column";
            column: string[];
            schema?: string | undefined;
            table?: string | undefined;
            database?: string | undefined;
            catalog?: string | undefined;
        }[] | undefined;
    } | {
        kind: "wildcard";
        schema?: string | undefined;
        table?: string | undefined;
    };
    name: string;
    alias?: string | undefined;
}, {
    content: {
        kind: "column";
        column: string[];
        schema?: string | undefined;
        table?: string | undefined;
        database?: string | undefined;
        catalog?: string | undefined;
    } | {
        kind: "expression";
        text: string;
        columns?: {
            kind: "column";
            column: string[];
            schema?: string | undefined;
            table?: string | undefined;
            database?: string | undefined;
            catalog?: string | undefined;
        }[] | undefined;
    } | {
        kind: "wildcard";
        schema?: string | undefined;
        table?: string | undefined;
    };
    name: string;
    alias?: string | undefined;
}>;
export type Column = z.infer<typeof Column>;
export declare const From: z.ZodType<From>;
export type From = {
    table?: EntityRef | undefined;
    select?: Select | undefined;
    alias?: string | undefined;
};
export declare const Select: z.ZodObject<{
    command: z.ZodLiteral<"SELECT">;
    language: z.ZodLiteral<"DML">;
    operation: z.ZodLiteral<"read">;
    result: z.ZodObject<{
        columns: z.ZodArray<z.ZodObject<{
            content: z.ZodDiscriminatedUnion<"kind", [z.ZodObject<{
                kind: z.ZodLiteral<"wildcard">;
                table: z.ZodOptional<z.ZodString>;
                schema: z.ZodOptional<z.ZodString>;
            }, "strip", z.ZodTypeAny, {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            }, {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            }>, z.ZodObject<z.objectUtil.extendShape<{
                database: z.ZodOptional<z.ZodString>;
                catalog: z.ZodOptional<z.ZodString>;
                schema: z.ZodOptional<z.ZodString>;
            }, {
                kind: z.ZodLiteral<"column">;
                table: z.ZodOptional<z.ZodString>;
                column: z.ZodArray<z.ZodString, "many">;
            }>, "strict", z.ZodTypeAny, {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            }, {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            }>, z.ZodObject<{
                kind: z.ZodLiteral<"expression">;
                text: z.ZodString;
                columns: z.ZodOptional<z.ZodArray<z.ZodObject<z.objectUtil.extendShape<{
                    database: z.ZodOptional<z.ZodString>;
                    catalog: z.ZodOptional<z.ZodString>;
                    schema: z.ZodOptional<z.ZodString>;
                }, {
                    kind: z.ZodLiteral<"column">;
                    table: z.ZodOptional<z.ZodString>;
                    column: z.ZodArray<z.ZodString, "many">;
                }>, "strict", z.ZodTypeAny, {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }, {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }>, "many">>;
            }, "strip", z.ZodTypeAny, {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            }, {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            }>]>;
            alias: z.ZodOptional<z.ZodString>;
            name: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }, {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }>, "many">;
        distinct: z.ZodOptional<z.ZodBoolean>;
    }, "strip", z.ZodTypeAny, {
        columns: {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }[];
        distinct?: boolean | undefined;
    }, {
        columns: {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }[];
        distinct?: boolean | undefined;
    }>;
    from: z.ZodType<From, z.ZodTypeDef, From>;
    joins: z.ZodOptional<z.ZodArray<z.ZodType<From, z.ZodTypeDef, From>, "many">>;
}, "strict", z.ZodTypeAny, {
    command: "SELECT";
    language: "DML";
    operation: "read";
    result: {
        columns: {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }[];
        distinct?: boolean | undefined;
    };
    from: From;
    joins?: From[] | undefined;
}, {
    command: "SELECT";
    language: "DML";
    operation: "read";
    result: {
        columns: {
            content: {
                kind: "column";
                column: string[];
                schema?: string | undefined;
                table?: string | undefined;
                database?: string | undefined;
                catalog?: string | undefined;
            } | {
                kind: "expression";
                text: string;
                columns?: {
                    kind: "column";
                    column: string[];
                    schema?: string | undefined;
                    table?: string | undefined;
                    database?: string | undefined;
                    catalog?: string | undefined;
                }[] | undefined;
            } | {
                kind: "wildcard";
                schema?: string | undefined;
                table?: string | undefined;
            };
            name: string;
            alias?: string | undefined;
        }[];
        distinct?: boolean | undefined;
    };
    from: From;
    joins?: From[] | undefined;
}>;
export type Select = z.infer<typeof Select>;
//# sourceMappingURL=select.d.ts.map