"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var plugin_commonjs_1 = require("@rollup/plugin-commonjs");
var plugin_terser_1 = require("@rollup/plugin-terser");
var plugin_json_1 = require("@rollup/plugin-json");
var plugin_typescript_1 = require("@rollup/plugin-typescript");
var plugin_node_resolve_1 = require("@rollup/plugin-node-resolve");
// used to generate a min file to be used in backend/lib/azimutt_web/templates/website/_editors-script.html.heex
exports.default = {
    input: 'src/index.ts',
    output: [{
            file: 'out/bundle.js',
            format: 'cjs',
            sourcemap: true,
        }, {
            file: 'out/bundle.min.js',
            format: 'iife',
            sourcemap: true,
            name: 'sql',
            plugins: [(0, plugin_terser_1.default)()],
        }],
    plugins: [
        (0, plugin_node_resolve_1.default)(),
        (0, plugin_commonjs_1.default)(),
        (0, plugin_json_1.default)(),
        (0, plugin_typescript_1.default)(),
    ]
};
